mod Mauxb logic: 'cl'

incl Mtex

rem 
  \para \bf  Exponentiation of two.  \end 

fun E 'Tex_f2_n_e'
  E(0) = 1
  E(x+1) = 2*E(x)

thm E_is_not_zero
  E(x) != 0
proof 
 ind N; x @ 0; x
  proved
  proved..

thm E_is_one
  E(x) = 1 <-> x = 0
proof 
 case N; x @ 0; x1
  proved
  proved..

thm E_gt_one
  E(x) > 1 <-> x != 0
proof 
 cut* E(x) > 1 <-> E(x) != 0 & E(x) != 1
  weak* E(x) > 1 <-> x != 0
   split* E(x) > 1 <-> E(x) != 0 & E(x) != 1.2,0,0
    proved
    proved..
  use E_is_not_zero; x
   use E_is_one.0; x proved....

thm E_plus
  E(x+y) = E(x)*E(y)
proof 
 ind N; x @ 0; x
  proved
  proved..

thm E_minus
  x >= y -> E(x-y) = E(x)/E(y)
proof 
 ind N; x; y @ 0; x
  proved
  case N; y @ 0; y1
   proved
   inst \a y(x >= y -> E(x-y) = E(x)/E(y)); y1 proved....

thm E_cancel_eq
  E(x) = E(y) <-> x = y
proof 
 ind N; x; y @ 0; x
  use E_is_one.0; y proved.
  case N; y @ 0; y1
   proved
   inst \a y(E(x) = E(y) <-> x = y).0; y1 proved....

thm E_cancel_le
  E(x) <= E(y) <-> x <= y
proof 
 ind N; x; y @ 0; x
  use E_is_not_zero; y proved.
  case N; y @ 0; y1
   use E_is_not_zero; x proved.
   inst \a y(E(x) <= E(y) <-> x <= y).0; y1 proved....

thm E_cancel_lt
  E(x) < E(y) <-> x < y
proof 
 ind N; x; y @ 0; x
  use E_gt_one.0; y proved.
  case N; y @ 0; y1
   use E_is_not_zero; x proved.
   inst \a y(E(x) < E(y) <-> x < y).0; y1 proved....

